//+------------------------------------------------------------------+
//|                                           Correlation_script.mq4 |
//|                                         Copyright  2007, Xupypr |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Xupypr"
#property show_inputs

extern datetime Begin_Time=D'2011.09.01 00:00:00';//  
extern datetime End_Time=D'2011.11.17 00:00:00';//  
extern bool Curr_Time=false;//   
extern string Base="CHFJPY";// 

int start()
{
 //    
 //Copyright  2007, zIG & akadex
 int start=iBarShift(NULL,0,Begin_Time);
 int finish;
 if (Curr_Time) finish=0;
 else finish=iBarShift(NULL,0,End_Time);
 int period=start-finish;
 int bar=iBarShift(Base,0,iTime(NULL,0,finish));
 double avgBase=iMA(Base,0,period,0,MODE_SMA,PRICE_CLOSE,bar);
 double avgSmb=iMA(Symbol(),0,period,0,MODE_SMA,PRICE_CLOSE,finish);
 double E=0;
 double D=0;
 double F=0;
 for(int i=finish;i<=start;i++)
 {
  bar=iBarShift(Base,0,iTime(NULL,0,i));
  E+=((iClose(Base,0,bar))-avgBase)*((iClose(Symbol(),0,i))-avgSmb);
  D+=MathPow(((iClose(Base,0,bar))-avgBase),2);
  F+=MathPow(((iClose(Symbol(),0,i))-avgSmb),2);
 }
 D=MathSqrt(D);
 F=MathSqrt(F);
 double R=E/(D*F);
 Comment("    = ",DoubleToStr(R,4));
 return(0);
}